package CORBAbroker;

/**
 *	Generated from IDL definition of interface "Broker"
 *	@author JacORB IDL compiler 
 */

public class _BrokerStub
	extends org.omg.CORBA.portable.ObjectImpl
	implements CORBAbroker.Broker
{
	private String[] ids = {"IDL:CORBAbroker/Broker:1.0","IDL:omg.org/CORBA/Object:1.0"};
	public String[] _ids()
	{
		return ids;
	}

	public final static java.lang.Class _opsClass = CORBAbroker.BrokerOperations.class;
	public void free(long ticketId) throws CORBAbroker.BrokerPackage.TicketNotFound
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "free", true);
				_os.write_longlong(ticketId);
				_is = _invoke(_os);
				return;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				if( _id.equals("IDL:CORBAbroker/Broker/TicketNotFound:1.0"))
				{
					throw CORBAbroker.BrokerPackage.TicketNotFoundHelper.read(_ax.getInputStream());
				}
				else 
					throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "free", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			BrokerOperations _localServant = (BrokerOperations)_so.servant;
			try
			{
			_localServant.free(ticketId);
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return;
		}

		}

	}

	public void stop(long ticketId) throws CORBAbroker.BrokerPackage.TicketNotFound
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "stop", true);
				_os.write_longlong(ticketId);
				_is = _invoke(_os);
				return;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				if( _id.equals("IDL:CORBAbroker/Broker/TicketNotFound:1.0"))
				{
					throw CORBAbroker.BrokerPackage.TicketNotFoundHelper.read(_ax.getInputStream());
				}
				else 
					throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "stop", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			BrokerOperations _localServant = (BrokerOperations)_so.servant;
			try
			{
			_localServant.stop(ticketId);
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return;
		}

		}

	}

	public void start(long ticketId) throws CORBAbroker.BrokerPackage.TicketNotFound
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "start", true);
				_os.write_longlong(ticketId);
				_is = _invoke(_os);
				return;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				if( _id.equals("IDL:CORBAbroker/Broker/TicketNotFound:1.0"))
				{
					throw CORBAbroker.BrokerPackage.TicketNotFoundHelper.read(_ax.getInputStream());
				}
				else 
					throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "start", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			BrokerOperations _localServant = (BrokerOperations)_so.servant;
			try
			{
			_localServant.start(ticketId);
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return;
		}

		}

	}

	public java.lang.String[] suggest(java.lang.String[] req)
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "suggest", true);
				CORBAbroker.BrokerPackage.reservationHelper.write(_os,req);
				_is = _invoke(_os);
				java.lang.String[] _result = CORBAbroker.BrokerPackage.reservationHelper.read(_is);
				return _result;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "suggest", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			BrokerOperations _localServant = (BrokerOperations)_so.servant;
			java.lang.String[] _result;			try
			{
			_result = _localServant.suggest(req);
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return _result;
		}

		}

	}

	public long reserve(java.lang.String[] cr, short pid)
	{
		while(true)
		{
		if(! this._is_local())
		{
			org.omg.CORBA.portable.InputStream _is = null;
			try
			{
				org.omg.CORBA.portable.OutputStream _os = _request( "reserve", true);
				CORBAbroker.BrokerPackage.reservationHelper.write(_os,cr);
				_os.write_short(pid);
				_is = _invoke(_os);
				long _result = _is.read_longlong();
				return _result;
			}
			catch( org.omg.CORBA.portable.RemarshalException _rx ){}
			catch( org.omg.CORBA.portable.ApplicationException _ax )
			{
				String _id = _ax.getId();
				throw new RuntimeException("Unexpected exception " + _id );
			}
			finally
			{
				this._releaseReply(_is);
			}
		}
		else
		{
			org.omg.CORBA.portable.ServantObject _so = _servant_preinvoke( "reserve", _opsClass );
			if( _so == null )
				throw new org.omg.CORBA.UNKNOWN("local invocations not supported!");
			BrokerOperations _localServant = (BrokerOperations)_so.servant;
			long _result;			try
			{
			_result = _localServant.reserve(cr,pid);
			}
			finally
			{
				_servant_postinvoke(_so);
			}
			return _result;
		}

		}

	}

}
