/*
 * Created on Sep 13, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package reflector;

import java.io.IOException;
import java.net.URL;
import java.util.Vector;

import negotiator.NegotiationResult;

import com.ibm.aglet.AgletException;
import com.ibm.aglet.AgletProxy;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class AdaptClone extends AdaptStrategy
{
	/**
	 * 
	 */
	public AdaptClone()
	{
		super();
	}

	/**
	 * @param reflectorProxy
	 * @param neg
	 */
	public AdaptClone(AgletProxy reflectorProxy, AgletProxy neg)
	{
		super(reflectorProxy, neg);
	}
			
	/* (non-Javadoc)
	 * @see reflector.AdaptStrategy#chooseBestDestination(java.util.Vector)
	 */
	public void chooseBestDestination(Vector destinations)
	{
		//Vector destinations=negotiate();
		URL address=null;
		NegotiationResult winner=null;
		
		System.out.println("Running Cloning strategy");
		
		//TODO: Implement recognition of better QOS offer
		
		if(destinations.size()>0)
		{
			winner =(NegotiationResult)destinations.firstElement();
			System.out.println("Better location is host "+winner.getHost());
			address =winner.getHost();
		 	
			try
			{
				AgletProxy cloneProxy = (AgletProxy) proxy.clone();
				cloneProxy.dispatch(address);			
			} catch (IOException e)
			{
				e.printStackTrace();
			} catch (AgletException e)
			{
				e.printStackTrace();
			} catch (CloneNotSupportedException e)
			{
				e.printStackTrace();
			}
		}
		else
			System.out.println("[ADAPTATION] Negotiations failed, impossible to migrate");
	}

}
