/*
 * Created on Sep 13, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package reflector;

import java.io.IOException;
import java.net.URL;

import negotiator.NegotiationResult;

import com.ibm.aglet.AgletException;
import com.ibm.aglet.AgletProxy;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class AdaptMigrate extends AdaptStrategy
{
	/**
	 * 
	 */
	public AdaptMigrate()
	{
		super();
	}

	/**
	 * @param reflectorProxy
	 * @param neg
	 */
	public AdaptMigrate(AgletProxy reflectorProxy, AgletProxy neg)
	{
		super(reflectorProxy, neg);
	}
	
	
			
	/* (non-Javadoc)
	 * @see java.lang.Runnable#run()
	 */
	public void run()
	{
		// Vector destinations=negotiate();
		
		URL address=null;
		NegotiationResult winner=null;
		
		System.out.println("Running Migration strategy");
		
		//TODO: If localhost's offer is the same of any other host, it's better stay than migrate
		winner = bestOffer(destinations);
		
	 	if(winner!=null)
	 	{
			System.out.println("[ADAPTATION] Better location is host "+winner.getHost());
		 	address = winner.getHost();
		 	
			try
			{
				//negotiator.dispose();
				proxy.dispatch(address);
			} catch (IOException e)
			{
				e.printStackTrace();
			} catch (AgletException e)
			{
				e.printStackTrace();
			}	
	 	}
		else
			System.out.println("[ADAPTATION] Negotiations failed, impossible to migrate");
	}
}
