/*
 * Created on Jan 12, 2004
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package reflector;

import java.util.Vector;

import negotiator.NegotiationAgentInit;

import com.ibm.aglet.AgletProxy;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class RoamingStrategyLinear extends RoamingStrategy
{
	/**
	 * 
	 */
	public RoamingStrategyLinear()
	{
		super();
	}

	/**
	 * @param reservs
	 * @param reqPid
	 * @param negPx
	 */
	public RoamingStrategyLinear(Vector reservs, Integer reqPid, AgletProxy negPx)
	{
		super(reservs, reqPid, negPx);
	}

	/* (non-Javadoc)
	 * @see reflector.RoamingStrategy#definePath()
	 */
	public Vector definePath()
	{
		Vector agentInits=new Vector();
			
		NegotiationAgentInit agInit = new NegotiationAgentInit(reservations, requesterPid, this.hostsToVisit, negProxy);
		agentInits.add(agInit);
		
		return(agentInits);
	}

}
