package reflector;

import java.io.IOException;

import com.ibm.aglet.Aglet;

/*
 * Created on Jun 25, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class ReflectorAglet extends Aglet
{
	transient ReflectorServer server;	
	
	public void onCreation(Object init)
	{
			try
			{
				server = new ReflectorServer();
			} catch (IOException e)
			{
				System.out.println("[ERROR] Port 5567 already open by another application");
				e.printStackTrace();
			}
	}
	
	public void run()
	{
		server.start();
	}
	
	public void onDisposing()
	{
		System.out.println("Tentou destruir");
		server.stopWaiting();
	}
}
