package CORBAbroker;

/**
 *	Generated from IDL definition of interface "Broker"
 *	@author JacORB IDL compiler 
 */

public abstract class BrokerPOA
	extends org.omg.PortableServer.Servant
	implements org.omg.CORBA.portable.InvokeHandler, CORBAbroker.BrokerOperations
{
	static private final java.util.Hashtable m_opsHash = new java.util.Hashtable();
	static
	{
		m_opsHash.put ( "free", new java.lang.Integer(0));
		m_opsHash.put ( "stop", new java.lang.Integer(1));
		m_opsHash.put ( "start", new java.lang.Integer(2));
		m_opsHash.put ( "suggest", new java.lang.Integer(3));
		m_opsHash.put ( "reserve", new java.lang.Integer(4));
	}
	private String[] ids = {"IDL:CORBAbroker/Broker:1.0","IDL:omg.org/CORBA/Object:1.0"};
	public CORBAbroker.Broker _this()
	{
		return CORBAbroker.BrokerHelper.narrow(_this_object());
	}
	public CORBAbroker.Broker _this(org.omg.CORBA.ORB orb)
	{
		return CORBAbroker.BrokerHelper.narrow(_this_object(orb));
	}
	public org.omg.CORBA.portable.OutputStream _invoke(String method, org.omg.CORBA.portable.InputStream _input, org.omg.CORBA.portable.ResponseHandler handler)
		throws org.omg.CORBA.SystemException
	{
		org.omg.CORBA.portable.OutputStream _out = null;
		// do something
		// quick lookup of operation
		java.lang.Integer opsIndex = (java.lang.Integer)m_opsHash.get ( method );
		if ( null == opsIndex )
			throw new org.omg.CORBA.BAD_OPERATION(method + " not found");
		switch ( opsIndex.intValue() )
		{
			case 0: // free
			{
			try
			{
				long _arg0=_input.read_longlong();
				_out = handler.createReply();
				free(_arg0);
			}
			catch(CORBAbroker.BrokerPackage.TicketNotFound _ex0)
			{
				_out = handler.createExceptionReply();
				CORBAbroker.BrokerPackage.TicketNotFoundHelper.write(_out, _ex0);
			}
				break;
			}
			case 1: // stop
			{
			try
			{
				long _arg0=_input.read_longlong();
				_out = handler.createReply();
				stop(_arg0);
			}
			catch(CORBAbroker.BrokerPackage.TicketNotFound _ex0)
			{
				_out = handler.createExceptionReply();
				CORBAbroker.BrokerPackage.TicketNotFoundHelper.write(_out, _ex0);
			}
				break;
			}
			case 2: // start
			{
			try
			{
				long _arg0=_input.read_longlong();
				_out = handler.createReply();
				start(_arg0);
			}
			catch(CORBAbroker.BrokerPackage.TicketNotFound _ex0)
			{
				_out = handler.createExceptionReply();
				CORBAbroker.BrokerPackage.TicketNotFoundHelper.write(_out, _ex0);
			}
				break;
			}
			case 3: // suggest
			{
				java.lang.String[] _arg0=CORBAbroker.BrokerPackage.reservationHelper.read(_input);
				_out = handler.createReply();
				CORBAbroker.BrokerPackage.reservationHelper.write(_out,suggest(_arg0));
				break;
			}
			case 4: // reserve
			{
				java.lang.String[] _arg0=CORBAbroker.BrokerPackage.reservationHelper.read(_input);
				short _arg1=_input.read_short();
				_out = handler.createReply();
				_out.write_longlong(reserve(_arg0,_arg1));
				break;
			}
		}
		return _out;
	}

	public String[] _all_interfaces(org.omg.PortableServer.POA poa, byte[] obj_id)
	{
		return ids;
	}
}
