package cpuJApi;

public class ProcStats
{
    public long clock;  // in us
    public long usage;   // in us.
    public boolean nonconformFlag;  // conformance 0/1.
    public boolean overrunFlag; 
    public CpuReserve cpuReserve;
    public long apDeadline;
    public boolean permNonconformFlag; 
    public int overrunItr;      // its number of iterations that it may have overrun.
    
    public long accUsage;  // in us
    public int accNumNonconform;
    public int accNumOverrun;
    public int accNumPermNonconform;
    public int accNumDeadlineMiss;
    public int accItr;
    

    public ProcStats() {
	clock = 0;
	usage = 0;
	nonconformFlag = false;
	cpuReserve = new CpuReserve();
	apDeadline = 0;
	permNonconformFlag = false;
	overrunItr = 0;
	accUsage = 0;
	accNumNonconform = 0;
	accNumPermNonconform = 0;
	accNumDeadlineMiss = 0;
	accItr = 0;
    }

    public String toString() {
	return("clock:" + clock +
	       " usage:" + usage +
	       " ncFlag:" + nonconformFlag +
	       " overrunFlag:" + overrunFlag +
	       " apDeadline:" + apDeadline +
	       " pncFlag:" + permNonconformFlag +
	       " overrunItr:" + overrunItr +
	       " accUsage:" + accUsage +
	       " accNumNc:" + accNumNonconform +
	       " accNumOv:" + accNumOverrun +
	       " accNumPcn:" + accNumPermNonconform + 
	       " accNumDm:" + accNumDeadlineMiss + 
	       " accItr:" + accItr +
	       " reserve:" + cpuReserve.toString());
    }   
}
