package cpuJApi;

public class Processor {
    public double availPermUtil;  // amount of available permanent partition 
    public double tsRatio;       // size of TS partition.
    public double overrunRatio;  // size of Overrun partition.
    public double permRatio;     // size of RT(permanent) partition.
    public long permUsage;  // accumulative usage in permanent partition.
    public long burstUsage;  // accumulative usage serving bursts.
    public long nonconformUsage;  // accumulative usage for nonconformed overruns. 
    public long probeUsage;  // accumulative usage for probes.
    public long tsUsage;  // accumulative usage for TS processes.

    public Processor() {
	availPermUtil = 0;
	tsRatio = 0;
	overrunRatio = 0;
	permRatio = 0;
	permUsage = 0;
	burstUsage = 0;
	nonconformUsage = 0;
	probeUsage = 0;
	tsUsage = 0;
    }
};
