/*
 * Created on Dec 15, 2003
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package negotiator;

import java.io.Serializable;
import java.util.Vector;

import com.ibm.aglet.AgletProxy;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class NegotiationAgentInit implements Serializable
{
	private Vector qosLevels;
	private Integer requesterPid;
	private Vector destinations;
	private AgletProxy father;
	
	public NegotiationAgentInit(Vector ql, Integer rp, Vector dst, AgletProxy neg)
	{
		this.qosLevels=ql;
		this.requesterPid=rp;
		this.destinations=dst;
		this.father=neg;		
	}
	
	public NegotiationAgentInit()
	{}
	
	/**
	 * @return
	 */
	public Vector getQosLevels()
	{
		return qosLevels;
	}

	/**
	 * @return
	 */
	public Integer getRequesterPid()
	{
		return requesterPid;
	}

	/**
	 * @return
	 */
	public Vector getDestination()
	{
		return destinations;
	}

	/**
	 * @return
	 */
	public AgletProxy getFather()
	{
		return father;
	}

}
