/*
 * Created on Jan 12, 2004
 *
 * Created by Roberto S. Cardoso <speicys@ime.usp.br>
 */
package reflector;

import java.util.Iterator;
import java.util.Vector;

import negotiator.NegotiationAgentInit;

import com.ibm.aglet.AgletProxy;

/**
 * @author Roberto S. Cardoso
 *
 * 
 */
public class RoamingStrategyParallel extends RoamingStrategy
{

	/**
	 * 
	 */
	public RoamingStrategyParallel()
	{
		super();
	}

	/**
	 * @param reservs
	 * @param reqPid
	 * @param negPx
	 */
	public RoamingStrategyParallel(Vector reservs, Integer reqPid, AgletProxy negPx)
	{
		super(reservs, reqPid, negPx);
	}

	/* (non-Javadoc)
	 * @see reflector.RoamingStrategy#negotiate()
	 */
	public Vector definePath()
	{
		Vector agentInits=new Vector();
				
		for(Iterator it=this.hostsToVisit.iterator();it.hasNext();)
		{
			Vector path=new Vector();
			path.add(it.next());
			NegotiationAgentInit agInit = new NegotiationAgentInit(reservations, requesterPid, path, negProxy);
			agentInits.add(agInit);
		}
		
		return(agentInits);
	}
}
